
// Copyright (C) Tom Horsley, 2001. All rights reserved.

#include <windows.h>
#include <ctype.h>
#include <string.h>

int WINAPI
WinMain(
   HINSTANCE hInstance,
   HINSTANCE hPrevInstance,
   LPSTR lpCmdLine,
   int nCmdShow)
{
   char * msgbuf = new char [4096];
   for ( ; ; ) {
      LPSTR cmdarg = NULL;
      if (lpCmdLine != NULL) {
         while (isspace(*lpCmdLine)) ++lpCmdLine;
         cmdarg = lpCmdLine;
         while ((*lpCmdLine != '\0') && (! isspace(*lpCmdLine))) ++lpCmdLine;
         if (*lpCmdLine != '\0') {
            *lpCmdLine++ = '\0';
         }
      }
      if ((cmdarg != NULL) && (cmdarg[0] != '\0')) {
         if (cmdarg[0] == '/') {
            cmdarg[0] = '-';
         }
         if (cmdarg[1] == '/') {
            cmdarg[1] = '-';
         }
         if ((strcmp(cmdarg, "--help") == 0) ||
             (strcmp(cmdarg, "-h") == 0) ||
             (strcmp(cmdarg, "-H") == 0) ||
             (strcmp(cmdarg, "-?") == 0)) {
            strcpy(msgbuf,
"ntpoke - poke the NTPTime service\n\
usage: ntpoke [--help]\n\
\n\
--help          print this message and exit\n\
\n\
This program pokes the NTPTime service so that it will attempt to set the\n\
time right away, regardless of any timeout or dialup connection it may be\n\
waiting on.\n");
            MessageBox(NULL, msgbuf, "ntpoke", MB_OK);
            return 0;
         } else {
            strcpy(msgbuf, "Unrecognized argument: ");
            strcat(msgbuf, cmdarg);
            MessageBox(NULL, msgbuf, "ntpoke",
                       MB_OK | MB_ICONEXCLAMATION);
            return 2;
         }
      } else {
         // PUT CODE HERE
         HANDLE ev = OpenEvent(EVENT_MODIFY_STATE, FALSE,
                               "Global\\NTPTimeEvent");
         if (ev == NULL) {
            ev = OpenEvent(EVENT_MODIFY_STATE, FALSE, "NTPTimeEvent");
         }
         if (ev == NULL) {
            strcpy(msgbuf,
"ntpoke unable to open the NTPTimeEvent. Perhaps the NTPTime service\n\
is not running.\n");
            MessageBox(NULL, msgbuf, "ntpoke",
                       MB_OK | MB_ICONEXCLAMATION);
            return 2;
         } else {
            SetEvent(ev);
            CloseHandle(ev);
         }
         break;
      }
   }
   return 0;
}
