#ifndef raise_priority_h
#define raise_priority_h

// Copyright (C) Tom Horsley, 1997. All rights reserved.

#include <windows.h>

// The RaisePriority class raises the priority of the current process as
// high as it can for the duration of its existence. Typical use is to
// declare an object of this type in a lexical block where the priority
// needs to be high.
//
class RaisePriority {
public:

      // Raise the priority on creation.
      //
   RaisePriority();

      // Restore original priority on descruction.
      //
   ~RaisePriority();

public:

   HANDLE process_handle;
   DWORD orig_class;
};

#endif // raise_priority_h
