#ifndef lasterr_exception_h
#define lasterr_exception_h

// Copyright (C) Tom Horsley, 1997. All rights reserved.

#include "base-exception.h"
#include <windows.h>

// LastErrorException is used to record exception info generated because
// of a failure in a win32 API which sets the GetLastError() value.
//
// The constructor takes a printf-like format string. The error number
// specific description is appened to the end of the formatted text.
//
class LastErrorException : public BaseException {
public:

      // Use this to pass in explicit error number.
      //
   LastErrorException(
      DWORD init_error_number,
      const char * fmt,
      ...) throw();

      // Use this to pick up GetLastError() value implicitly.
      //
   LastErrorException(
      const char * fmt,
      ...) throw();

   LastErrorException(const LastErrorException& rhs) throw();

   virtual
   ~LastErrorException() throw();

   LastErrorException &
   operator=(const LastErrorException & rhs) throw();

private:

   void
   CommonFormat(DWORD error_number) throw();

   struct extra_errmsg_info {
      DWORD errnum;
      const char * errmsg;
   };
   static const extra_errmsg_info winsock_errors[];
};

#endif // lasterr_exception_h
